.\" Copyright 1996 Rob W.W. Hooft (hooft@embl-heidelberg.de)
.\"
.\" Distribute freely
.TH MAN 1 "3 March 1996" "*NIX" "Users Manual"
.SH NAME
man, apropos, makewhatis \-  display on-line reference manual information
.SH SYNOPSIS
.B man [ section ] 
.I name
.LP
.B man -l
.I filename
.LP
.B man -k
.I keyword
.LP
.B apropos
.I keyword
.LP
.B makewhatis
.I [ manroot ] 
.LP
.B man -m
.I [ manroot ]
.LP 
.B man -v
.SH DESCRIPTION
This manual describes a Python implementation of a manual page browser.

The man program, like any other manual pager, will look through the 
manual pages on the system to find help on a command, library function,
or file format. 

Manual pages can be found on the system in different directories. The
location of these directories is derived from the MANPATH environment
variable. If the MANPATH environment variable is not set, the PATH
environment variable is scanned, and for each of the \"bin\"
directories, the existance of a corresponding "man" directory is
checked. The "man" directories found in this process are then used as if
they were given in the MANPATH.

Manual pages are found in subdirectories of the "man" directories: one
subdirectory for each section of the manual. Normal sections recognized
by default by this implementation are 1,2,3,4,5,6,7,8,9,l,n and o.

Manual pages are displayed on the screen using a "PAGER". Which pager
to use is derived from the "MANPAGER" environment variable, or if 
that is not present, from the "PAGER" environment variable. If neither
of the two variables is set, "less" is used by default.

Using the invokation "man name" all manual pages that match the name
will be shown in random order. 

"man -v" will show the version number and exit.

Using "man -k subject" or "apropos subject" all one-line descriptions
of all manual pages are scanned for the subject, and all matching
descriptions are listed. "subject" is a "regular expression".  If you
do not know how to use regular expressions: just restrict yourself to
words, and it will work fine.

The "apropos" command uses the "whatis" database that can be created
using the "makewhatis" program. Makewhatis takes an optional argument:
if an argument is given, only the given man-root is treated; otherwise
all man-roots in the MANPATH are handled in order.

The most dangerous form of this script is invoked as "man -m"
("-m" for maintainance). This will clean up the manual
directories. At least: it does what I like! It compresses large files,
uncompresses small files, removes symbolic links and hard links, and
creates SO alias files for all names mentioned in a manual page. Be
very careful with this command. If you want to try it: first do it
under a user-id that can not write to the manual directories. The
diagnostic output will tell you what the script would have done if you
would have been root. Maintainance mode does NOT create the whatis
databases: you need to run "makewhatis" immediately afterwards.
Maintainance mode has the same optional argument as "makewhatis".

.SH WHATIS DATABASE

The whatis database files created by the "makewhatis" script are
called "pywhatis" and "pywhatis.gdbm" to prevent collisions with
other manual browsers. The ".gdbm" file is used to make a fast-lookup
of manual pages for the "man" program. This idea was stolen (as many
others) from the perl implementation of man by Tom Christiansen.

.SH ENVIRONMENT VARIABLES
MANPATH - series of manual page roots separated by ":"

PATH - used if MANPATH isn't set.

MANPAGER - used to select pager command.

PAGER - used if MANPAGER isn't set.

.SH FILES
 ..../pywhatis - whatis database

 ..../pywhatis.gdbm - index for fast access to manuals

.SH BUGS
The system manager probably needs to configure some variables in the
script.

An invalid regular expression given to "apropos" crashes the program.

It is not as flexible as other manual page viewers.

It doesn't try to run any pre-filters like "tbl" or "eqn".

It doesn't know about "cat" pages and preformatting.

It doesn't like any other architecture than .../man/man#/file.#

.SH AUTHOR
Rob W.W. Hooft, EMBL, 1996. (hooft@embl-heidelberg.de)
